%%%%%%%%%%%%%%%%%%
%This function is to generate 2D transformation
%x0 :    1D signal
%mask:  sampling mask
%n :    square root of length of signal
%AGr:   full measuring matrix
% y:    output observation samples
%%%%%%%%%%%%%%%%%%


function [y, AGr] = Gr(x0, mask)

randn('state',0)

x=reshape(x0,size(mask));

n=length(x);

AGr=randn(n,n);

AGr=orth(AGr')';

y0=AGr*x*AGr';

ymask=reshape(mask.*y0,n,n);

y=ymask(find(mask==1));
